/*
 * Created on 18-ene-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package people.ejb;

import java.rmi.RemoteException;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import javax.ejb.*;
import people.interfaces.*;
import people.exception.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.*;

/**
 * @ejb.bean name="PeopleFacade"
 *           display-name="Name for PeopleFacade"
 *           description="Description for PeopleFacade"
 *           jndi-name="ejb/PeopleFacade"
 *           type="Stateless"
 *           view-type="both"
 * 
 * @ejb.util generate="physical"
 */
public class PeopleFacadeBean implements SessionBean {
	
	UserLocalHome userHome = null;
	UserInfoLocalHome userInfoHome = null;
	GroupLocalHome groupHome = null;
	RolLocalHome rolHome = null;

	/**
	 * 
	 */
	public PeopleFacadeBean() {
		super();
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbActivate()
	 */
	public void ejbActivate() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbPassivate()
	 */
	public void ejbPassivate() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbRemove()
	 */
	public void ejbRemove() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#setSessionContext(javax.ejb.SessionContext)
	 */
	public void setSessionContext(SessionContext ctx)
		throws EJBException,
		RemoteException {
		// TODO Auto-generated method stub

	}

	/**
	 * Default create method
	 * 
	 * @throws CreateException
	 * @ejb.create-method
	 */
	public void ejbCreate() throws CreateException {
		// TODO Auto-generated method stub
		try {
			userHome = UserUtil.getLocalHome();
			userInfoHome = UserInfoUtil.getLocalHome();
			groupHome = GroupUtil.getLocalHome();
			rolHome = RolUtil.getLocalHome();
		} catch (Exception e) {
			throw new CreateException(e.getMessage());
		}
	}

	private boolean validarNIF(String NIF) {
		String calculNif = "TRWAGMYFPDXBNJZSQVHLCKE";
		boolean valid;
		int iNIF;
		int lletra;
		
		try {
			iNIF = Integer.parseInt(NIF.substring(0, 8));
			lletra = NIF.charAt(NIF.length() - 1);
			if (calculNif.charAt(iNIF % 23) == lletra) {
				valid = true;
			} else {
				valid = false;
			}
		} catch (Exception ex) {
			valid = false;
		}
		
		return valid;
	}
	
	public boolean validarEmail(String email) {
		// Expressio regular extreta de http://regexlib.com/
		Pattern p = Pattern.compile("^([0-9a-zA-Z]([-.\\w]*[0-9a-zA-Z])*@([0-9a-zA-Z][-\\w]*[0-9a-zA-Z]\\.)+[a-zA-Z]{2,9})$");
		Matcher m = p.matcher(email);
		if (m.find()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void altaUsuari(people.interfaces.UserValue value) throws CreateException, NIFIncorrecteException, EmailIncorrecteException {
		// TODO Auto-generated method stub
		if (! this.validarNIF(value.getNIF())) {
			throw new NIFIncorrecteException();
		}
		if (! this.validarEmail(value.getEmail())) {
			throw new EmailIncorrecteException();
		}
		userHome.create(value);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void baixaUsuari(String login) throws FinderException, RemoveException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		
		// Eliminem userinfo si te
		UserInfoLocal userInfo = user.getUserInfo();
		if (userInfo != null) {
			userInfo.remove();
		}
		
		// Treiem dels rols
		Collection rols = user.getRols();
		if (rols != null) {
			Iterator it = rols.iterator();
			while (it.hasNext()) {
				RolLocal r = (RolLocal)it.next();
				Collection users = r.getUsers();
				users.remove(user);
				r.setUsers(users);
			}
		}
		
		// Eliminem del grup
		GroupLocal grup = user.getGrup();
		if (grup != null) {
			Collection users = grup.getUsers();
			users.remove(user);
			grup.setUsers(users);
		}
		
		user.remove();
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public people.interfaces.UserValue getValorsUsuari(String login) throws FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		return user.getValors();
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void setValorsUsuari(String login, people.interfaces.UserValue value) throws FinderException,NIFIncorrecteException, EmailIncorrecteException {
		// TODO Auto-generated method stub
		if (! this.validarNIF(value.getNIF())) {
			throw new NIFIncorrecteException();
		}
		if (! this.validarEmail(value.getEmail())) {
			throw new EmailIncorrecteException();
		}
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		user.setValors(value);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public java.lang.Boolean validarPassword(String login, String password) throws FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		String currentPass = user.getPassword();
		if (currentPass.compareTo(password) == 0) {
			return new Boolean(true);
		} else {
			return new Boolean(false);
		}
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void altaGrup(people.interfaces.GroupValue value) throws CreateException {
		// TODO Auto-generated method stub
		groupHome.create(value);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void baixaGrup(String id) throws FinderException, RemoveException {
		// TODO Auto-generated method stub
		GroupLocal grup = groupHome.findByPrimaryKey(new GroupPK(id));
		
		// Treiem dels usuaris
		Collection users = grup.getUsers();
		if (users != null) {
			Iterator it = users.iterator();
			while (it.hasNext()) {
				UserLocal u = (UserLocal)it.next();
				u.setGrup(null);
			}
		}
		grup.remove();
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public people.interfaces.GroupValue getValorsGrup(String id) throws FinderException {
		// TODO Auto-generated method stub
		GroupLocal grup = groupHome.findByPrimaryKey(new GroupPK(id));
		return grup.getValors();
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void setValorsGrup(String id, people.interfaces.GroupValue value) throws FinderException {
		GroupLocal grup = groupHome.findByPrimaryKey(new GroupPK(id));
		grup.setValors(value);
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void altaRol(people.interfaces.RolValue value) throws CreateException {
		// TODO Auto-generated method stub
		rolHome.create(value);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void baixaRol(String id) throws FinderException, RemoveException {
		// TODO Auto-generated method stub
		RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		
		// Treiem dels usuaris
		Collection users = rol.getUsers();
		if (users != null) {
			Iterator it = users.iterator();
			while (it.hasNext()) {
				UserLocal u = (UserLocal)it.next();
				Collection r = u.getRols();
				r.remove(rol);
				u.setRols(r);
			}
		}
		
		rol.remove();
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public people.interfaces.RolValue getValorsRol(String id) throws FinderException {
		// TODO Auto-generated method stub
		RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		return rol.getValors();
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public Collection getRolsUsuari(String login) throws FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		
		Vector result = new Vector();
		Collection rols = user.getRols();
		Iterator it = rols.iterator();
		while(it.hasNext()) {
			RolLocal rol = (RolLocal)it.next();
			RolValue r = new RolValue();
			r.setID(rol.getID());
			result.add(r);
		}
		return result;
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public GroupValue getGrupUsuari(String login) throws FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		GroupLocal g = user.getGrup();
		if (g != null) {
			return g.getValors();
		} else {
			return null;
		}
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void setValorsRol(String id, people.interfaces.RolValue value) throws FinderException {
		RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		rol.setValors(value);
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void asignarUsuariInfo(String login, people.interfaces.UserInfoValue value) throws CreateException, FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		if (user.getUserInfo() == null) {
			UserInfoLocal userInfo = userInfoHome.create(value);
			user.setUserInfo(userInfo);
			userInfo.setUser(user);
		} else {
			UserInfoLocal userInfo = user.getUserInfo();
			userInfo.setValors(value);
		}
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void desasignarUsuariInfo(String login) throws FinderException, RemoveException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		user.setUserInfo(null);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public people.interfaces.UserInfoValue getValorsUsuariInfo(String login) throws FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		UserInfoLocal userInfo = user.getUserInfo();
		if (userInfo != null) {
			return userInfo.getValors();
		} else {
			return null;
		}
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void setValorsRol(String login, people.interfaces.UserInfoValue value) throws FinderException {
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		UserInfoLocal userInfo = user.getUserInfo();
		userInfo.setValors(value);
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void asignarUsuariAGrup(String login, String id) throws CreateException, FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		GroupLocal grup = groupHome.findByPrimaryKey(new GroupPK(id));
		user.setGrup(grup);
		
		Collection users = grup.getUsers();
		users.add(user);
		grup.setUsers(users);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void desasignarUsuariAGrup(String login, String id) throws CreateException, FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		GroupLocal grup = groupHome.findByPrimaryKey(new GroupPK(id));
		user.setGrup(null);
		
		Collection users = grup.getUsers();
		users.remove(user);
		grup.setUsers(users);
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void asignarRolAUsuari(String id, String login) throws CreateException, FinderException {
		// TODO Auto-generated method stub
		RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		Collection rols = user.getRols();
		rols.add(rol);
		user.setRols(rols);
		
		Collection users = rol.getUsers();
		users.add(user);
		rol.setUsers(users);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void desasignarRolAUsuari(String id, String login) throws CreateException, FinderException {
		// TODO Auto-generated method stub
		RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		Collection rols = user.getRols();
		rols.remove(rol);
		user.setRols(rols);
		
		Collection users = rol.getUsers();
		users.remove(user);
		rol.setUsers(users);
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public Collection llistatUsuarisAmbRol(String id) throws CreateException, FinderException {
		// TODO Auto-generated method stub
		RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		
		Vector result = new Vector();
		Collection users = rol.getUsers();
		Iterator it = users.iterator();
		while (it.hasNext()) {
			UserLocal u = (UserLocal) it.next();
			result.add(u.getValors());
		}
		return result;
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public Collection llistatRolsDelGrup(String id) throws CreateException, FinderException {
		// TODO Auto-generated method stub
		//RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		Collection rols = rolHome.findByGroup(id);
		
		Vector result = new Vector();
		Iterator it = rols.iterator();
		while (it.hasNext()) {
			RolLocal r = (RolLocal) it.next();
			result.add(r.getValors());
		}
		return result;
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public Collection llistatUsuaris() throws CreateException, FinderException {
		// TODO Auto-generated method stub
		//RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		Collection users = userHome.findAll();
		
		Vector result = new Vector();
		Iterator it = users.iterator();
		while (it.hasNext()) {
			UserLocal u = (UserLocal) it.next();
			result.add(u.getValors());
		}
		return result;
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public Collection llistatRols() throws CreateException, FinderException {
		// TODO Auto-generated method stub
		//RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		Collection rols = rolHome.findAll();
		
		Vector result = new Vector();
		Iterator it = rols.iterator();
		while (it.hasNext()) {
			RolLocal r = (RolLocal) it.next();
			result.add(r.getValors());
		}
		return result;
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public Collection llistatGrups() throws CreateException, FinderException {
		// TODO Auto-generated method stub
		//RolLocal rol = rolHome.findByPrimaryKey(new RolPK(id));
		Collection grups = groupHome.findAll();
		
		Vector result = new Vector();
		Iterator it = grups.iterator();
		while (it.hasNext()) {
			GroupLocal g = (GroupLocal) it.next();
			result.add(g.getValors());
		}
		return result;
	}
	
}