/*
 * Created on 21-ene-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package people.web;

import javax.servlet.http.HttpServlet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletConfig;
import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import people.interfaces.*;
import people.exception.*;

/**
 * Servlet Class
 *
 * @web.servlet              name="Control"
 *                           display-name="Name for Control"
 *                           description="Description for Control"
 * @web.servlet-mapping      url-pattern="/Control/*"
 * 
 * @web.ejb-ref              name="ejb/PeopleFacade"
 *                           type="Session"
 *                           home="people.interfaces.PeopleFacadeHome"
 *                           remote="people.interfaces.PeopleFacade"
 *                           description="Referencia al Session EJB PeopleFacade"
 * 
 * @jboss.ejb-ref-jndi       ref-name="ejb/PeopleFacade"
 *                           jndi-name="ejb/PeopleFacade"
 * 
 */
public class ControlServlet extends HttpServlet {
	PeopleFacadeHome peopleHome = null;
	PeopleFacade people = null;

	/**
	 * 
	 */
	public ControlServlet() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	private void gotoPage(String address, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	    RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(address);
	    dispatcher.forward(request, response);
	}

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		// TODO Auto-generated method stub
		try {
			peopleHome = PeopleFacadeUtil.getHome();
			people = peopleHome.create();
		} catch(Exception ex) {
			throw new ServletException("Error a la inicialitzacio del servlet.");
		}
	}

	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException,
		IOException {
		// TODO Auto-generated method stub
		//super.doGet(req, resp);
		doPost(req, resp);
	}

	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException,
		IOException {
		// TODO Auto-generated method stub
		String url = req.getRequestURI();
		
		String nextURL = "/index.jsp";
		try {
			// Segons la sollicitud de l'usuari...
			if(url.startsWith("/people/Control/users/list/")) {
				// Llistar usuaris
				req.setAttribute("llistat", people.llistatUsuaris());
				nextURL = "/users/index.jsp";
				gotoPage(nextURL, req, resp);
				
			} else	if(url.startsWith("/people/Control/users/new")) {
				// Nou usuari
				String login = req.getParameter("login");
				String nom = req.getParameter("nom");
				String cognom = req.getParameter("cognom");
				String address = req.getParameter("address");
				String telefon = req.getParameter("telefon");
				String nif = req.getParameter("nif");
				String email = req.getParameter("email");
				String password = req.getParameter("password");
				
				UserValue vUser = new UserValue();
				vUser.setAdress(address);
				vUser.setCognom(cognom);
				vUser.setEmail(email);
				vUser.setLogin(login);
				vUser.setNIF(nif);
				vUser.setNom(nom);
				vUser.setPassword(password);
				vUser.setTelefon(telefon);
				try {
					people.altaUsuari(vUser);
					nextURL = "/Control/users/list/";
					gotoPage(nextURL, req, resp);
				} catch (NIFIncorrecteException e) {
					nextURL = "/error.jsp";
					req.setAttribute("error", "NIF Incorrecte!");
					gotoPage(nextURL, req, resp);
				} catch (EmailIncorrecteException e) {
					nextURL = "/error.jsp";
					req.setAttribute("error", "Email Incorrecte!");
					gotoPage(nextURL, req, resp);
				}
				
			}else if(url.startsWith("/people/Control/users/modify")) {
				// Modificar usuari
				String id = req.getParameter("id");
				if (req.getParameter("nom") != null) {
					// Modifiquem
					String login = req.getParameter("id");
					String nom = req.getParameter("nom");
					String cognom = req.getParameter("cognom");
					String address = req.getParameter("address");
					String telefon = req.getParameter("telefon");
					String nif = req.getParameter("nif");
					String email = req.getParameter("email");
					String password = req.getParameter("password");
					
					UserValue vUser = new UserValue();
					vUser.setAdress(address);
					vUser.setCognom(cognom);
					vUser.setEmail(email);
					vUser.setLogin(login);
					vUser.setNIF(nif);
					vUser.setNom(nom);
					vUser.setPassword(password);
					vUser.setTelefon(telefon);
					
					try {
						people.setValorsUsuari(vUser.getLogin(), vUser);
						nextURL = "/Control/users/list/";
						gotoPage(nextURL, req, resp);
					} catch (NIFIncorrecteException e) {
						nextURL = "/error.jsp";
						req.setAttribute("error", "NIF Incorrecte!");
						gotoPage(nextURL, req, resp);
					} catch (EmailIncorrecteException e) {
						nextURL = "/error.jsp";
						req.setAttribute("error", "Email Incorrecte!");
						gotoPage(nextURL, req, resp);
					}
				} else {
					// Mostrem formulari per modificar
					req.setAttribute("user", people.getValorsUsuari(id));
					nextURL = "/users/modify.jsp";
					gotoPage(nextURL, req, resp);
				}
				
			} else if (url.startsWith("/people/Control/users/delete/")) {
				// Esborrar usuari
				String login = req.getParameter("id");
				people.baixaUsuari(login);
				nextURL = "/Control/users/list/";
				gotoPage(nextURL, req, resp);
				
			} else if (url.startsWith("/people/Control/users/info/")) {
				// Info associat al usuari
				String login = req.getParameter("id");
				if (req.getParameter("descripcio") != null) {
					// Modifiquem
					String descripcio = req.getParameter("descripcio");
					
					UserInfoValue vUserInfo = new UserInfoValue();
					vUserInfo.setID(login);
					vUserInfo.setDescripcio(descripcio);
					people.asignarUsuariInfo(login, vUserInfo);
					nextURL = "/Control/users/list/";
					gotoPage(nextURL, req, resp);
				} else {
					UserInfoValue vUserInfo = people.getValorsUsuariInfo(login);
					req.setAttribute("userInfo", vUserInfo);
					nextURL = "/users/info.jsp";
					gotoPage(nextURL, req, resp);
				}
				
			} else if (url.startsWith("/people/Control/users/roles/")) {
				// Rols de l'usuari
				String login = req.getParameter("id");
				req.setAttribute("rols", people.llistatRols());
				req.setAttribute("rolsUsuari", people.getRolsUsuari(login));
				nextURL = "/users/roles.jsp";
				gotoPage(nextURL, req, resp);
				
			} else if (url.startsWith("/people/Control/users/rolesAssign/")) {
				// Assignar rol a usuari
				String login = req.getParameter("id");
				String rol = req.getParameter("idRol");
				people.asignarRolAUsuari(rol, login);
				nextURL = "/Control/users/roles/";
				gotoPage(nextURL, req, resp);
				
			} else if (url.startsWith("/people/Control/users/rolesUnassign/")) {
				// Desassignar rol a usuari
				String login = req.getParameter("id");
				String rol = req.getParameter("idRol");
				people.desasignarRolAUsuari(rol, login);
				nextURL = "/Control/users/roles/";
				gotoPage(nextURL, req, resp);
				
			} else if (url.startsWith("/people/Control/users/group/")) {
				// Veure grup de l'usuari
				String login = req.getParameter("id");
				req.setAttribute("grups", people.llistatGrups());
				req.setAttribute("grupUsuari", people.getGrupUsuari(login));
				nextURL = "/users/group.jsp";
				gotoPage(nextURL, req, resp);
				
			} else if (url.startsWith("/people/Control/users/groupAssign/")) {
				// Establir grup del usuari
				String login = req.getParameter("id");
				String grup = req.getParameter("idGroup");
				people.asignarUsuariAGrup(login, grup);
				
				nextURL = "/Control/users/group/";
				gotoPage(nextURL, req, resp);
				
			}else if(url.startsWith("/people/Control/groups/list/")) {
				// Llistar grups
				req.setAttribute("llistat", people.llistatGrups());
				nextURL = "/groups/index.jsp";
				gotoPage(nextURL, req, resp);
				
			} else	if(url.startsWith("/people/Control/groups/new")) {
				// Nou grup
				String id = req.getParameter("id");
				
				GroupValue vGrup = new GroupValue();
				vGrup.setID(id);
				people.altaGrup(vGrup);
				nextURL = "/Control/groups/list/";
				gotoPage(nextURL, req, resp);
			
			} else if (url.startsWith("/people/Control/groups/delete/")) {
				// Esborrar grup
				String id = req.getParameter("id");
				people.baixaGrup(id);
				nextURL = "/Control/groups/list/";
				gotoPage(nextURL, req, resp);
				
			} else if (url.startsWith("/people/Control/groups/roles/")) {
				// Rols dels usuaris d'un grup
				String id = req.getParameter("id");
				req.setAttribute("llistat", people.llistatRolsDelGrup(id));
				nextURL = "/groups/roles.jsp";
				gotoPage(nextURL, req, resp);
				
			}else if(url.startsWith("/people/Control/roles/list/")) {
				// Llistar rols
				req.setAttribute("llistat", people.llistatRols());
				nextURL = "/roles/index.jsp";
				gotoPage(nextURL, req, resp);
				
			} else	if(url.startsWith("/people/Control/roles/new")) {
				// Nou rol
				String id = req.getParameter("id");
				
				RolValue vRol = new RolValue();
				vRol.setID(id);
				people.altaRol(vRol);
				nextURL = "/Control/roles/list/";
				gotoPage(nextURL, req, resp);
			
			} else if (url.startsWith("/people/Control/roles/delete/")) {
				// Esborrar rol
				String id = req.getParameter("id");
				people.baixaRol(id);
				nextURL = "/Control/roles/list/";
				gotoPage(nextURL, req, resp);
				
			} else if (url.startsWith("/people/Control/roles/users/")) {
				// Usuaris d'un rol
				String id = req.getParameter("id");
				req.setAttribute("llistat", people.llistatUsuarisAmbRol(id));
				nextURL = "/roles/users.jsp";
				gotoPage(nextURL, req, resp);
				
			} else {
				nextURL = "/error.jsp";
				req.setAttribute("error", "URL ("+url+") incorrecte!");
				gotoPage(nextURL, req, resp);
			}
			
		} catch (Exception e) {
			nextURL = "/error.jsp";
			req.setAttribute("error", "Excepcio:" + e.getMessage());
			gotoPage(nextURL, req, resp);
		}
		
	}

}